package com.loganmagnan.lasers.runnables;

import com.loganmagnan.lasers.Lasers;
import com.loganmagnan.lasers.utils.ColorUtils;
import net.md_5.bungee.api.ChatMessageType;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.entity.Player;

public class CooldownRunnable implements Runnable {

    private Lasers main = Lasers.getInstance();

    @Override
    public void run() {
        this.main.getCooldownManager().setCooldownCount(this.main.getCooldownManager().getCooldownCount() + 1);

        for (Player player : this.main.getServer().getOnlinePlayers()) {
            if (this.main.getCooldownManager().isOnCooldown(player.getUniqueId())) {
                int count = this.main.getCooldownManager().getCooldownTime(player.getUniqueId());
                count--;

                this.main.getCooldownManager().setCooldownTime(player.getUniqueId(), count);

                if (count == 0) {
                    this.main.getCooldownManager().getCooldown().remove(player.getUniqueId());
                    this.main.getCooldownManager().getCooldownTime().remove(player.getUniqueId());

                    player.sendMessage(ColorUtils.getMessageType("&aYou're no longer on cooldown"));
                }

                String string = "";

                for (int i = 0; i < count; i++) {
                    string += "&a|";
                }

                for (int i = 0; i < (10 - count); i++) {
                    string += "&7|";
                }

                player.spigot().sendMessage(ChatMessageType.ACTION_BAR, player.getUniqueId(), new TextComponent(ColorUtils.getMessageType("&8[" + string + "&8]")));
            }

            if (this.main.getCooldownManager().getCooldownCount() == 10) {
                this.main.getCooldownManager().setCooldownCount(0);
            }
        }
    }
}
